<?php
/**
 * ユニットが持つテーブルの生成を行う
 * @param tbl_unitのマスタ情報
 */
function extunit_install($param, $db)
{
    switch (DBTYPE) {
        case "pgsql":
            $sql[] = "CREATE TABLE  extunit_chattext  (
                 pageu_code  integer NOT NULL DEFAULT '0',
                 message  text,
                 message_color  varchar(24),
                 message_border  varchar(24),
                 face_icon  text,
                 face_icon_size  varchar(10),
                 name  text,
                 name_color  varchar(24),
                 layout  text,
                 fsize  text,
                 fcolor  text,
                 ffamily  text,
                 line_height  varchar(10),
                 shadow_x  integer,
                 shadow_y  integer,
                 shadow_blur  integer,
                 shadow_color  text,
                 letterspacing   varchar(10),
                 message_sp  text,
                 message_color_sp  varchar(24),
                 message_border_sp  varchar(24),
                 face_icon_sp  text,
                 face_icon_size_sp  varchar(10),
                 layout_sp  text,
                 fsize_sp  text,
                 fcolor_sp  text,
                 ffamily_sp  text,
                 line_height_sp   varchar(10),
                 shadow_x_sp  integer,
                 shadow_y_sp  integer,
                 shadow_blur_sp  integer,
                 shadow_color_sp  text,
                 letterspacing_sp   varchar(10),
                 bg_color  smallint DEFAULT '0',
                 bdr_type  smallint DEFAULT '0',
                 btm_padding  smallint DEFAULT '2',
                 bg_color_sp  smallint DEFAULT '0',
                 bdr_type_sp  smallint DEFAULT '0',
                 btm_padding_sp  smallint DEFAULT '2',
                 use_sp_flg  smallint default 1,
                 use_pc_flg  smallint default 1,
                 option_extend  smallint default 0,
                 extra_class  text,
                 unit_sync  smallint,
                 animatecsshelp  text,
                 animatecsshelp_speed  integer,
                 animatecsshelp_delay  integer,
                 animatecsshelp_timing  integer,
                primary key (pageu_code)
            )";
            $sql[] = "CREATE TABLE  extunit_chattext_tmp  (
                 pageu_code  integer NOT NULL DEFAULT '0',
                 message  text,
                 message_color  varchar(24),
                 message_border  varchar(24),
                 face_icon  text,
                 face_icon_size  varchar(10),
                 name  text,
                 name_color  varchar(24),
                 layout  text,
                 fsize  text,
                 fcolor  text,
                 ffamily  text,
                 line_height   varchar(10),
                 shadow_x  integer,
                 shadow_y  integer,
                 shadow_blur  integer,
                 shadow_color  text,
                 letterspacing   varchar(10),
                 message_sp  text,
                 message_color_sp  varchar(24),
                 message_border_sp  varchar(24),
                 face_icon_sp  text,
                 face_icon_size_sp  varchar(10),
                 layout_sp  text,
                 fsize_sp  text,
                 fcolor_sp  text,
                 ffamily_sp  text,
                 line_height_sp   varchar(10),
                 shadow_x_sp  integer,
                 shadow_y_sp  integer,
                 shadow_blur_sp  integer,
                 shadow_color_sp  text,
                 letterspacing_sp   varchar(10),
                 bg_color  smallint DEFAULT '0',
                 bdr_type  smallint DEFAULT '0',
                 btm_padding  smallint DEFAULT '2',
                 bg_color_sp  smallint DEFAULT '0',
                 bdr_type_sp  smallint DEFAULT '0',
                 btm_padding_sp  smallint DEFAULT '2',
                 use_sp_flg  smallint default 1,
                 use_pc_flg  smallint default 1,
                 option_extend  smallint default 0,
                 extra_class  text,
                 unit_sync  smallint,
                 animatecsshelp  text,
                 animatecsshelp_speed  integer,
                 animatecsshelp_delay  integer,
                 animatecsshelp_timing  integer,
                primary key (pageu_code)
            )";
            break;
        case "mysql":
            $sql[] = "CREATE TABLE  extunit_chattext  (
                 pageu_code  integer NOT NULL DEFAULT '0',
                 message  text,
                 message_color  varchar(24),
                 message_border  varchar(24),
                 face_icon  text,
                 face_icon_size  varchar(10),
                 name  text,
                 name_color  varchar(24),
                 layout  text,
                 fsize  text,
                 fcolor  text,
                 ffamily  text,
                 line_height   varchar(10),
                 shadow_x  integer,
                 shadow_y  integer,
                 shadow_blur  integer,
                 shadow_color  text,
                 letterspacing   varchar(10),
                 message_sp  text,
                 message_color_sp  varchar(24),
                 message_border_sp  varchar(24),
                 face_icon_sp  text,
                 face_icon_size_sp  varchar(10),
                 layout_sp  text,
                 fsize_sp  text,
                 fcolor_sp  text,
                 ffamily_sp  text,
                 line_height_sp   varchar(10),
                 shadow_x_sp  integer,
                 shadow_y_sp  integer,
                 shadow_blur_sp  integer,
                 shadow_color_sp  text,
                 letterspacing_sp   varchar(10),
                 bg_color  smallint DEFAULT '0',
                 bdr_type  smallint DEFAULT '0',
                 btm_padding  smallint DEFAULT '2',
                 bg_color_sp  smallint DEFAULT '0',
                 bdr_type_sp  smallint DEFAULT '0',
                 btm_padding_sp  smallint DEFAULT '2',
                 use_sp_flg  smallint default 1,
                 use_pc_flg  smallint default 1,
                 option_extend  smallint default 0,
                 extra_class  text,
                 unit_sync  smallint,
                 animatecsshelp  text,
                 animatecsshelp_speed  integer,
                 animatecsshelp_delay  integer,
                 animatecsshelp_timing  integer,
                primary key (pageu_code)
            )TYPE=InnoDB DEFAULT CHARSET=utf8;";
            $sql[] = "CREATE TABLE  extunit_chattext_tmp  (
                 pageu_code  integer NOT NULL DEFAULT '0',
                 message  text,
                 message_color  varchar(24),
                 message_border  varchar(24),
                 face_icon  text,
                 face_icon_size  varchar(10),
                 name  text,
                 name_color  varchar(24),
                 layout  text,
                 fsize  text,
                 fcolor  text,
                 ffamily  text,
                 line_height   varchar(10),
                 shadow_x  integer,
                 shadow_y  integer,
                 shadow_blur  integer,
                 shadow_color  text,
                 letterspacing   varchar(10),
                 message_sp  text,
                 message_color_sp  varchar(24),
                 message_border_sp  varchar(24),
                 face_icon_sp  text,
                 face_icon_size_sp  varchar(10),
                 layout_sp  text,
                 fsize_sp  text,
                 fcolor_sp  text,
                 ffamily_sp  text,
                 line_height_sp   varchar(10),
                 shadow_x_sp  integer,
                 shadow_y_sp  integer,
                 shadow_blur_sp  integer,
                 shadow_color_sp  text,
                 letterspacing_sp   varchar(10),
                 bg_color  smallint DEFAULT '0',
                 bdr_type  smallint DEFAULT '0',
                 btm_padding  smallint DEFAULT '2',
                 bg_color_sp  smallint DEFAULT '0',
                 bdr_type_sp  smallint DEFAULT '0',
                 btm_padding_sp  smallint DEFAULT '2',
                 use_sp_flg  smallint default 1,
                 use_pc_flg  smallint default 1,
                 option_extend  smallint default 0,
                 extra_class  text,
                 unit_sync  smallint,
                 animatecsshelp  text,
                 animatecsshelp_speed  integer,
                 animatecsshelp_delay  integer,
                 animatecsshelp_timing  integer,
                primary key (pageu_code)
            )TYPE=InnoDB DEFAULT CHARSET=utf8;";
            //mysql 5.5対応
            if (isset($db->dbversion) && version_compare($db->dbversion, "5.0.0", ">=")) {
                //mysql5.0以上の時はTYPEをENGINEに置換え
                foreach ((array)$sql as $k => $v) {
                    $sql[$k] = str_replace('TYPE=InnoDB', 'ENGINE = InnoDB', $v);
                }
            }
            break;
        default:
            return false;
            break;
    }
    //sqlの実行
    if (!is_array($sql)||!count($sql)>0) {
        //テーブルのないモジュール、ユニットは存在させない
        return false;
    }
    foreach ($sql as $key => $val) {
        if (!$db->query($val)) {
            return false;
        }
    }

    return true;
}
