<style>
/*{literal}*/
input.text { width: 4em; }
.radioLayout label { border: 2px solid #ccc; padding: 6px; box-sizing: border-box; }
.radioLayout label:nth-child(n+3) { margin-left: 10px; }
.radioLayout :checked + label { border-color: #00A1FD; }
/*{/literal}*/
</style>
<script src="{$BINGOTOPURL}/js/jquery.bingo/slider.js" type="text/javascript" defer></script>
<script type="text/javascript" src="{$BINGOTOPURL}/usr-data/extunits/extChatText/admin/form.js" defer></script>
<script type="text/javascript" src="{$BINGOTOPURL}/admin/js/imgselecter.js"></script>
<script type="text/javascript" src="{$BINGOTOPURL}/admin/js/fontselector.js"></script>
<script type="text/javascript" src="{$BINGOTOPURL}/admin/js/cookie.js"></script>
<div id="unitContainerMain" class="unitContainer">
  <div class="unitContentsTtl">
    <h3>チャットテキスト<span class="_unitClass">[.extChatText]</span></h3>
    {$form.buttons.BTNback.html}
  </div>
  <form {$form.attributes}>
    {$form.hidden}
    <div class="unitContentsBoxOuter">
      <!--基本設定/-->
      <div class="unitContentsBaseBox">
        <span class="pr10">{_gettext msg="B_T00891"}{*表示設定*}</span>
        <span class="decoChecboxBtn">{$form.use_pc_flg.html}{$form.use_sp_flg.html}</span>
        <!--PC・タブレットとリンクするチェックボックス/-->
        <span class="pr10">{_gettext msg="B_T01440"}{*SP設定*}</span>
        <span class="radioBtnBox pr20">{$form.unit_sync.html}</span>
        <!--/PC・タブレットとリンクするチェックボックス-->
        <!--class/--><span class="pr10">{_gettext msg="B_T01383"}{*class*}</span>{$form.extra_class.html}
        {if version_compare($smarty.const.BINGO_VERSION, '1.7.3', '>=')}
        {include file="`$smarty.const.SYSTEM_PATH`app/view/pc/admin/_common/animate.tpl"}
        {/if}
      </div>
         <!--/基本設定-->
      {if is_array($ERROR) && 0 < $ERROR|@count}
      <!--エラーコメント/-->
      <p class="errBox" style="padding-left: 1em;">{'<br>'|implode:$ERROR}</p>
      <!--/エラーコメント-->
      {/if}
      <div class="inner">
        <!--基本設定/-->
        <div class="col" style="margin-bottom: 25px;">
            <div class="inner flexBox wr100">
              <div class="col w11em"><strong>{_gettext msg="基本設定"}<span style="display: inline-block; margin-left: 5px; text-align: center; font-size: 11px; background:#333; color: #FFF; border-radius: 50%; width: 15px; height: 15px; line-height: 15px; cursor: pointer;" class="help" data-tip data-tip-link="https://users.bingo-cms.jp/dl/manual/unit/extChatText.pdf" data-tip-title="使用方法やデザインTIPSはマニュアルをご覧下さい">?</span></strong></div>
              <div class="col">
                <div class="formGroup formBlockLine wr100">
                  <div class="inner" style="margin-right: 17px;">
                    <p class="formTitle">{_gettext msg="名前"}</p>
                    <div class="partsBox" style="margin-right: 0;">
                      {$form.name.html}</a>
                    </div>
                  </div>
                  <div class="inner" style="margin-right: 17px;">
                    <p class="formTitle">{_gettext msg="名前色"}</p>
                    <div class="partsBox" style="margin-right: 0;">
                      {$form.name_color.html}<span class="picker" data-image="../../../admin/common-img/btn_color_pic.png" data-w="35" data-h="25"></p>
                    </div>
                  </div>
                  <div class="inner" style="margin-right: 17px;">
                    <p class="formTitle">{_gettext msg="レイアウト"}</p>
                    <div class="partsBox radioLayout" style="margin-right: 0;">
                      {$form.layout.html}
                    </div>
                  </div>
                </div>
              </div>
          </div>
        </div>
        <!--/基本設定-->
        <!--デバイスタブ/-->
        <ul class="deviceTabMenu">
          <li><a class="active" href="javascript:void(0);" data-device="pc" data-prefix=""><span>PC・Tablet・SP</span></a></li>
          <li style="display: none;"><a href="javascript:void(0);" data-device="sp" data-prefix=""><span>SP</span></a></li>
        </ul>
        <!--/デバイスタブ-->
        <div class="col">
          <div class="inner">
            <!--PC/-->
            <div class="viewpc" style="display: block;">
              <div class="colOuter clearfix">
                <!--PCテキスト設定/-->
                <div class="col1" style="float: left; width: calc(100% - 430px);">
                  <div class="flexBox border">
                    <div class="col w10em"><strong>{_gettext msg="テキスト"}</strong></div>
                    <div class="col">
                      <div class="formGroup formBlockLine wr100">
                        <!--テキスト/-->
                        <div class="inner wr100">{$form.message.html}</div>
                        <!--/テキスト-->
                      </div>
                      <div class="formGroup formBlockLine wr100 pc2sp" style="margin-bottom: 10px;">
                        <div class="inner">
                          <div class="partsBox" style="height: auto;">
                            <span class="pc2sp margin0" style="margin-right: 17px;"><input type="checkbox" name="pc2sp[message]" id="pc2sp_message"><label for="pc2sp_message">{_gettext msg="B_T01458"}{*SPも同じ内容で更新*}</label></span>
                          </div>
                        </div>
                      </div>
                      <div class="formGroup formBlockLine wr100">
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="背景色"}</p>
                          <div class="partsBox">
                            {$form.message_color.html}<span class="picker" data-image="../../../admin/common-img/btn_color_pic.png" data-w="35" data-h="25"></p>
                          </div>
                        </div>
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="B_T01444"}{*影の色・透過*}</p>
                          <div class="partsBox">
                            {$form.shadow_color.html}<span class="picker picker_alpha" data-image="../../../admin/common-img/btn_color_pic.png" data-w="35" data-h="25"></span>
                          </div>
                        </div>
                        {* <div class="inner">
                          <p class="formTitle">{_gettext msg="枠色"}</p>
                          <div class="partsBox">
                            {$form.message_border.html}<span class="picker picker_alpha" data-image="../../../admin/common-img/btn_color_pic.png" data-w="35" data-h="25"></p>
                          </div>
                        </div> *}
                      </div>
                    </div>
                  </div>
                  <!--PCアイコン-->
                  <div class="flexBox border">
                    <div class="col w10em"><strong>{_gettext msg="アイコン"}</strong></div>
                    <div class="col">
                      <!--PCファイル選択/-->
                      <div class="formGroup formBlockLine wr100">
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="ファイル"}</p>
                          <div class="partsBox">
                            <div class="uploadArea">
                              <div class="bBtnImgSelect mr5"><a href="{$BINGOTOPURL}/admin/imgmngr/index.php?units=face_icon&l=-99" onclick="m_win(this.href,'{_gettext msg="B_T00080"}','1024','800');return false;" title="{_gettext msg="B_T01431"}">{_gettext msg="B_T01431"}</a></div>
                            </div>
                            <div id="selecter-face_icon" style="display:none;"></div>
                            {if $image}<img src="{$image}" width="100"><br />
                            <input type="hidden" name="img_del" value="0" />
                            <input id="del" type="checkbox" name="img_del" value="1" />
                            <label for="del">{_gettext msg="B_T01430"}</label>
                            {/if}
                          </div>
                        </div>
                        <!--PCサイズ/-->
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="サイズ"}{*サイズ*}</p>
                          <div class="partsBox">{$form.face_icon_size.html}</div>
                        </div>
                        <!--/PCサイズ-->
                      </div>
                      <div class="formGroup formBlockLine wr100 pc2sp" style="margin-bottom: 10px;">
                        <div class="inner">
                          <div class="partsBox" style="height: auto;">
                            <span class="pc2sp margin0" style="margin-right: 17px;"><input type="checkbox" name="pc2sp[face_icon]" id="pc2sp_face_icon"><label for="pc2sp_face_icon">{_gettext msg="B_T01458"}{*SPも同じ内容で更新*}</label></span>
                          </div>
                        </div>
                      </div>
                      <!--/PCファイル選択-->
                    </div>
                  </div>
                  <!--/PCアイコン-->
                  <!--PCフォント/-->
                  <div class="flexBox border">
                    <div class="col w10em"><strong>{_gettext msg="B_T01392"}{*フォント*}</strong></div>
                    <div class="col">
                      <div class="formGroup formBlockLine wr100">
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="B_T01408"}{*サイズ*}</p>
                          <div class="partsBox">{$form.fsize.html}</div>
                        </div>
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="B_T01422"}{*フォントファミリー*}</p>
                          <div class="partsBox">
                            {$form.ffamily.html}<a href="#" class="bSelecterBtn mr5" data-sync="[name=ffamily]">{_gettext msg='B_T01431'}{*フォント選択*}</a>
                            {if $font}<p class="selectedFontFamily">{$font.font_family|escape}<a href="javascript:void(0);" class='_fontClear' data-sync="[name=ffamily]">×</a></p>{/if}
                          </div>
                        </div>
                      </div>
                      <div class="formGroup formBlockLine wr100">
                        <div class="inner">
                          <div class="innerGroup" style=" width: 230px;">
                            <p class="formTitle">{_gettext msg="B_T01419"}{*行間*}</p>
                            <div class="partsBox">
                              <div id="bInputRange1" class="bInputRange" data-sync="#line_height">
                                <div class="inner">
                                  <div class="point"></div>
                                </div>
                              </div>
                              &nbsp;{$form.line_height.html}&nbsp;em
                            </div>
                          </div>
                        </div>
                        <div class="inner">
                          <div style=" width: 247px;">
                          <p class="formTitle">{_gettext msg="B_T01420"}{*文字間*}</p>
                            <div class="partsBox">
                              <div id="bInputRange2" class="bInputRange" data-sync="#letterspacing">
                                <div class="inner">
                                  <div class="point"></div>
                                </div>
                              </div>
                              &nbsp;{$form.letterspacing.html}&nbsp;em
                            </div>
                          </div>
                        </div>
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="B_T01404"}{*カラー*}</p>
                          <div class="partsBox">
                            {$form.fcolor.html}<span class="picker" data-image="../../../admin/common-img/btn_color_pic.png" data-w="35" data-h="25"></p>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                  <!--/PCフォント-->

                </div>
                <!--/PCテキスト設定-->
                <!--PCオプション設定/-->
                <div class="col2 optionBox" style="float: right; width: 400px;">
                  {include file='unit_option.tpl' unit_option_device='pc'}
                </div>
                <!--/PCオプション設定-->
              </div>
            </div>
            <!--/PC-->

            <!--SP/-->
            <div class="viewsp" style="display: none;">
              <div class="colOuter clearfix">
                <!--SPテキスト設定/-->
                <div class="col1" style="float: left; width: calc(100% - 430px);">
                  <div class="flexBox border">
                    <div class="col w10em"><strong>{_gettext msg="テキスト"}</strong></div>
                    <div class="col">
                      <div class="formGroup formBlockLine wr100">
                        <!--テキスト/-->
                        <div class="inner wr100">{$form.message_sp.html}</div>
                        <!--/テキスト-->
                      </div>
                      <div class="formGroup formBlockLine wr100">
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="背景色"}</p>
                          <div class="partsBox">
                            {$form.message_color_sp.html}<span class="picker" data-image="../../../admin/common-img/btn_color_pic.png" data-w="35" data-h="25"></p>
                          </div>
                        </div>
                        <div class="inner">
                            <p class="formTitle w10em">{_gettext msg="B_T01444"}{*影の色・透過*}</p>
                            <div class="partsBox">
                              {$form.shadow_color_sp.html}<span class="picker picker_alpha" data-image="../../../admin/common-img/btn_color_pic.png" data-w="35" data-h="25"></span>
                            </div>
                        </div>
                      </div>
                    </div>
                  </div>
                  <!--SPアイコン-->
                  <div class="flexBox border">
                    <div class="col w10em"><strong>{_gettext msg="アイコン"}</strong></div>
                    <div class="col">
                      <!--SPファイル選択/-->
                      <div class="formGroup formBlockLine wr100">
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="ファイル"}</p>
                          <div class="partsBox">
                            <div class="uploadArea">
                              <div class="bBtnImgSelect mr5"><a href="{$BINGOTOPURL}/admin/imgmngr/index.php?units=face_icon_sp&l=-99" onclick="m_win(this.href,'{_gettext msg="B_T00080"}','1024','800');return false;" title="{_gettext msg="B_T01431"}">{_gettext msg="B_T01431"}</a></div>
                            </div>
                            <div id="selecter-face_icon_sp" style="display:none;"></div>
                            {if $image_sp}<img src="{$image_sp}" width="100"><br />
                            <input type="hidden" name="img_del_sp" value="0" />
                            <input id="del_sp" type="checkbox" name="img_del_sp" value="1" />
                            <label for="del_sp">{_gettext msg="B_T01430"}</label>
                            {/if}
                          </div>
                        </div>
                        <!--SPサイズ/-->
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="サイズ"}{*サイズ*}</p>
                          <div class="partsBox">{$form.face_icon_size_sp.html}</div>
                        </div>
                        <!--/SPサイズ-->
                      </div>
                      <!--/SPファイル選択-->
                    </div>
                  </div>
                  <!--/SPアイコン-->
                  <!--SPフォント/-->
                  <div class="flexBox border">
                    <div class="col w10em"><strong>{_gettext msg="B_T01392"}{*フォント*}</strong></div>
                    <div class="col">
                      <div class="formGroup formBlockLine wr100">
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="B_T01408"}{*サイズ*}</p>
                          <div class="partsBox">{$form.fsize_sp.html}</div>
                        </div>
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="B_T01422"}{*フォントファミリー*}</p>
                          <div class="partsBox">
                            {$form.ffamily_sp.html}<a href="#" class="bSelecterBtn mr5" data-sync="[name=ffamily_sp]">{_gettext msg='B_T01431'}{*フォント選択*}</a>
                            {if $font_sp}<p class="selectedFontFamily">{$font_sp.font_family|escape}<a href="javascript:void(0);" class='_fontClear'  data-sync="[name=ffamily_sp]">×</a></p>{/if}
                          </div>
                        </div>
                      </div>
                      <div class="formGroup formBlockLine wr100">
                        <div class="inner">
                          <div class="innerGroup" style=" width: 230px;">
                            <p class="formTitle">{_gettext msg="B_T01419"}{*行間*}</p>
                            <div class="partsBox">
                              <div id="bInputRange1_sp" class="bInputRange" data-sync="#line_height_sp">
                                <div class="inner">
                                  <div class="point"></div>
                                </div>
                              </div>
                              &nbsp{$form.line_height_sp.html}&nbsp;em
                            </div>
                          </div>
                        </div>
                        <div class="inner">
                          <div style=" width: 247px;">
                            <p class="formTitle">{_gettext msg="B_T01420"}{*文字間*}</p>
                            <div class="partsBox">
                              <div id="bInputRange2_sp" class="bInputRange" data-sync="#letterspacing_sp">
                                <div class="inner">
                                  <div class="point"></div>
                                </div>
                              </div>
                              &nbsp{$form.letterspacing_sp.html}&nbsp;em
                            </div>
                          </div>
                        </div>
                        <div class="inner">
                          <p class="formTitle">{_gettext msg="B_T01404"}{*カラー*}</p>
                          <div class="partsBox">
                            {$form.fcolor_sp.html}<span class="picker picker_alpha" data-image="../../../admin/common-img/btn_color_pic.png" data-w="35"  data-h="25"></p>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                  <!--/SPフォント-->
                </div>
                <!--/SPテキスト設定-->
                <!--SPオプション設定/-->
                <div class="col2 optionBox" style="float: right; width: 400px;">
                  {include file='unit_option.tpl' unit_option_device='sp'}
                </div>
                <!--/SPオプション設定-->
              </div>
            </div>
            <!--/SP-->
            <!--フォント選択ポップアップ/-->
            <!-- <div class="bSelectWindow close" id="bSelectWindow1" style="display: none;">
              <div class="fontSelectHeader">
                <h3>{_gettext msg='B_T01431'}{*フォント選択*}</h3>
                <a class="btnClose" href="#" onclick="j$('.bSelectWindow').fadeOut(300).addClass('close');">キャンセル</a>
              </div>
              <div class="inner">
                <ul>
                </ul>
              </div>
              <div class="fontSelectFooter">
               <a class="btnClose" href="#" onclick="j$('.bSelectWindow').fadeOut(300).addClass('close');">キャンセル</a>
              </div>
            </div> -->
            <!--/フォント選択ポップアップ-->
          </div>
        </div>
      </div>
    </div>
    <div class="unitContentsBtn">
      <div class="unitContentsBtnInner">
        <div class="inner">
          <table>
            <tr>
              <td>{$form.buttons.BTNback.html}</td>
              <td>{$form.buttons.BTNsave.html}</td>
            </tr>
          </table>
        </div>
      </div>
    </div>
  </form>
</div>
<script type="text/javascript">
/*<[CDATA[*/ 　
  var bingotopurl = "{$BINGOTOPURL}";
  //wysiwygの設定
  var editorStyle = "inline";
  var editorHeight = "24em";
  //Font
  var fonts = {ldelim}
      "dummy": "dummy",{foreach from=$fonts item="f" key="k"},"{$k}":"{$f}"{/foreach}
  {rdelim};
  //PC・SP同期
  var chain = false;
  //オプションPC・SP同期
  var extend = false;
  //スライダー
  var sp_slider1, sp_slider2, sp_slider3, sp_slider4, sp_slider5;
  {literal}
  var tips = new bTip('[data-tip]',{container:document, trigger: 'mouseenter', time: 300, offset: [0, 4], axis: 'right center'});
  j$(tips).on('bTipShow', function(e, data){
      j$(data.tip).find('a').attr('target', '_blank').css({color: '#fff'});
  });
  {/literal}
/*]]>*/
</script>
{$COLORPICKER}
